//provides tcp remote-logging capability

#ifndef __CONSOLE_SERVER__
#define __CONSOLE_SERVER__

#include "btkcam.h"

#ifdef WIN32
#include <process.h>
#include "win32.h"
#else
#include <pthread.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <sys/poll.h>

#endif

#include <fcntl.h>
#include <sys/types.h>

#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>

#define _MAX_CONCURRENT_CONNECTIONS 5

class console_server
{
	public:
	unsigned short int port;
	char converted_message[16384];
	
	console_server( unsigned  int listening_port );
	~console_server();
		
	void broadcast(char *message);
		
	int fds[_MAX_CONCURRENT_CONNECTIONS];
	pthread_t listener;
	
	//static members
	static pthread_mutex_t console_server_lock;
	
	static int listener_socket;
	static void *listener_thread( void *arg );
	static void listener_thread_cleanup( void );
	
	static int network_write(int fd, char *buffer, unsigned int length);
};

#endif
